InstanceHub = class(Turbine.UI.Control)
function InstanceHub:Constructor()
    Turbine.UI.Control.Constructor(self);
    SwitchAction[Settings.InstanceVersion]()
    
    self.CheckInstanceState = function(sender, line)
        if string.find(line, "New Quest: Remmorchant") then
            --  ChatOutput(string.sub(line, string.len( line ), string.len(line)))
            if Settings.EEnabled then
                effectsWindow:Message(8, "<rgb=#0008CFF> Welcome to the Remmorchant! </rgb>",nil,false)
            end
            Settings.InstanceState = true
            Settings.InstanceVersion = 1
            SwitchAction[Settings.InstanceVersion]()
        end

        if string.find(line, "Entered the") then
            if Settings.EEnabled and Settings.InstanceState then
                effectsWindow:Message(8, "<rgb=#0008CFF> Leaving so soon? </rgb>",nil,false)
            end
            Settings.InstanceState = false
            Settings.InstanceVersion = 0
            SwitchAction[Settings.InstanceVersion]()
        end

        if string.find(line, "resets") then
            -- DG
            if string.find(line, "Dâr Narbugud resets in") then
                Settings.InstanceState = true
                if Settings.EEnabled then
                    effectsWindow:Message(8, "<rgb=#0008CFF> Welcome to Dâr Narbugud! </rgb>",nil,false)
                end
                Settings.InstanceVersion = 2
                SwitchAction[Settings.InstanceVersion]()
            end

            -- Rift
            if string.find(line, "The Rift of Nûrz Ghâshu resets in") then
                Settings.InstanceState = true
                if Settings.EEnabled then
                    effectsWindow:Message(8, "<rgb=#0008CFF> Welcome to The Rift of Nûrz Ghâshu! </rgb>",nil,false)
                end
                Settings.InstanceVersion = 3
                SwitchAction[Settings.InstanceVersion]()
            end

        end
    end
end

SwitchAction = {
    -- DefaultState
    [0] = 
    function()

    end,
    -- Remmorchant
    [1] = 
    function()

    end,
    -- Dâr Narbugud
    [2] =
    function()
        E.AllEffectsAdded["Gloom"] = nil
        E.EffectsAdded["Gloom"] = nil
    end,
    -- The Rift of Nûrz Ghâshu
    [3] =
    function()

    end,
}