 Turbine.Chat.Received = function(sender,args)
    if not(UsedChatChannels[args.ChatType]) then return end
    if args.ChatType == Turbine.ChatType.Fellowship or args.ChatType == Turbine.ChatType.Raid then
        if Party == nil then return end
        local leader = Party:GetLeader():GetName()
        local player = Player:GetName()
        local senderName = GetName2(args.Message) 
        if senderName == leader or (player == leader and (string.find(args.Message, "%[To Fellowship%]") or string.find(args.Message, "%[To Raid%]"))) or SpecialNames[senderName] or (SpecialNames[player] and (string.find(args.Message, "%[To Fellowship%]") or string.find(args.Message, "%[To Raid%]"))) then           
            if(string.find(args.Message, "countdown")) then
                local number = tonumber(string.sub(args.Message, string.find(args.Message, "countdown") + 10, string.len(args.Message)))
                if number ~= nil then                 
                    countdownWindow:Countdown(number)
                end
            end
                    
            if(string.find(args.Message, "noteAdd")) then
                noteWindow.noteWindow:AppendText(string.sub(args.Message, string.find(args.Message, "noteAdd") + 8, string.len(args.Message)))
            end

            if(string.match(args.Message, "noteClear")) then
                noteWindow.noteWindow:SetText("")
                noteWindow:SetVisible(true)
            end

            --Ready check events start
            if(string.find(args.Message, " Initiate Readycheck")) then
                RcWindow:MakeReadyCheck()
                ReadyCheck:SetVisible(false)
                RCButtonWindow:SetVisible(false)
                ReadyCheck:MakeNewReadyCheck()
                Sounds:PlaySoundEffect(SoundEffects["Rc"]) 
            end

            if(string.find(args.Message, " Force Reload")) then
                ReloadPlugin()
            end
        end

        if senderName == "Arandour" or player == "Arandour" then
            if string.find(args.Message, "Amazing") then
                Sounds:PlaySoundEffect(SoundEffects["Amazing"])
            end
        end


        -- Handle self ready
        if RcWindow:OngoingReadycheck()  then
            if string.find(args.Message, " Ready") and not(string.find(args.Message, " Initiate Readycheck" )) then
                if GetName2(args.Message) == "Ready" then 
                    RcWindow:ActionCheck()
                    ReadyCheck:SetVisible()
                end
            end
        end

        -- Handle readycheck udpates
        if ReadyCheck:ReadyCheckActive() then
            if string.find(args.Message, " Ready") and not(string.find(args.Message, " Initiate Readycheck" )) then
                local playerName = ""
                for word in string.gmatch(args.Message, "%S+") do
                    if(word == "Not" or word == "Ready") then
                        break
                    end  
                    playerName = word
                end
                playerName = GetName2(args.Message)
                if playerName == "Ready" then
                    playerName = Player:GetName()
                end

                if string.find(args.Message, " Not Ready") then
                    ReadyCheck:UpdateReadycheckMember(playerName, false)
                else
                    ReadyCheck:UpdateReadycheckMember(playerName, true)
                end
            end
        end

        
    elseif args.ChatType == Turbine.ChatType.Say then
        --ChatOutput("Say"..args.Message)
        --ReloadPlugin()
        if string.find(args.Message, "You say, 'clear'") then
            ClearUI()
        end
        AlertMagic(args.Message)
        --HandleNewLock(args.Message)
    elseif args.ChatType == Turbine.ChatType.Quest then
        if InstanceController ~= nil then 
            InstanceController:CheckInstanceState(args.Message)
        end
    elseif args.ChatType == Turbine.ChatType.Standard then
        --ChatOutput(args.Message)
        --ChatOutput(GetChestName(args.Message))
        if InstanceController ~= nil then 
            InstanceController:CheckInstanceState(args.Message)
        end
        HandleNewLock(args.Message)

        --[[
        if string.find(args.Message, "Raid") or string.find(args.Message, "Fellowship") then
            ReloadPlugin()
        end
        --]]
        
        -- [[
        if string.find( args.Message, " has joined your Fellowship." ) or 
        string.find( args.Message, " has joined your Raid." ) or
        string.find( args.Message, "You have joined a Fellowship." ) or
        string.find( args.Message, "You have joined a Raid." ) or
        string.find( args.Message, " has left your Fellowship." ) or
        string.find( args.Message, " has left your Raid." ) or
        string.find( args.Message, "You leave your Fellowship." ) or
        string.find( args.Message, "You leave your Raid." ) or
        string.find( args.Message, "You dismiss " ) or
        string.find( args.Message, " from the Raid." ) or
        string.find( args.Message, " has been dismissed from your Fellowship." ) or
        string.find( args.Message, " has been dismissed from your Raid." ) or
        string.find( args.Message, "You have been dismissed from your Raid." ) or
        string.find( args.Message, "You have been dismissed from your Fellowship." ) or
        string.find( args.Message, "Your Fellowship has been disbanded." ) or
        string.find( args.Message, "Your Raid has been disbanded." ) or
        string.find( args.Message, "You have joined the chat room for your raid, raid chat is now available." ) or
        string.find( args.Message, "You have joined the chat room for your Fellowship, Fellowship chat is now available." ) or
        string.find( args.Message, "the leader of the raid") or
        string.find( args.Message, "the leader of the fellowship") then
            ReloadPlugin()
        end
        --]]
    elseif args.ChatType == Turbine.ChatType.Death then
        local name = nil
        if string.find(args.Message, "defeated") then
            name = string.match(args.Message, "defeated ".."(.+)".. "%.")
        end
        if string.find(args.Message, "has been defeated") then
            name = string.match(args.Message,"(.+)" .. "% has been defeated.")
        end
        if Settings.AEnabled and name ~= "" then rezTracker:Death(name) end

        if string.find(args.Message, "Your mighty blow defeated the") then
            if string.find(args.Message, "Your mighty blow defeated") then
                local kb = string.match(args.Message, "Your mighty blow defeated the (.+)%.")
                AddKB(kb)
            elseif string.find(args.Message, "Your mighty blow defeated The") then
                local kb = string.match(args.Message, "Your mighty blow defeated The (.+)%.")
                AddKB(kb)

            end
        elseif string.find(args.Message, "Your mighty blow topples") then
            local kb = string.match(args.Message, "Your mighty blow topples (.+)%.")
            AddKB(kb)
        end
        if string.find(args.Message, " incapacitated you.") or string.find(args.Message, "You have been incapacitated by misadventure.") then
            local kb = string.match(args.Message, "(.+) incapacitated you.")
            AddDeath(kb)
        end
        --ChatOutput(args.Message)
    elseif args.ChatType == Turbine.ChatType.EnemyCombat then
            local source,_,skillName,target,_ = string.match(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")

            --ChatOutput(skillName)

            if DamageLUT[skillName] then
                if skillName == "Steadfast Barrage" and Settings.AEnabled then
                    messageWindow:Message(2, "Barrage from: <rgb=#FF0000>".. source .. "</rgb>", TyrantIcon, false)
                end

                local alert = E.SkillNames[skillName]
                if alert ~= nil then
                    messageWindow:Message(alert[1], alert[2], alert[3], alert[4])
                end

                local timer = TDamage[skillName]
                if timer ~= nil then
                    skillCounters:NewTimer(timer[1], timer[2])
                end
            end
    end
 end

 function CompareIt(a, b)
    ChatOutput(a)
    ChatOutput(b)
    if string.find(a, b) then return true end
end

 function AlertMagic(message)
    --ChatOutput(message) 
    --ChatOutput(sender)  
    local sender = GetName(message)
    --ChatOutput(sender)
    if sender ~= nil then 
        --ChatOutput(sender)
        --if Settings.LEnabled then
        --    logWindow:Message(sender, false)
        --end
        if Settings.AEnabled then
            local temp1 = A[sender]
            if temp1 ~= nil then 
                for key, value in pairs(temp1) do
                    if string.find(string.gsub(message, "[%p%c%s]", ""), string.gsub(key, "[%p%c%s]", "")) then
                        messageWindow:Message(value[1], value[2], value[3], value[4])
                        if value[5] ~= nil then Sounds:PlaySoundEffect(value[5]) end
                        break
                    end
                end
            end
        end
        if Settings.SEnabled then 
            local temp2 = T[sender]
            if temp2 ~= nil then
                for key, value in pairs(temp2) do
                    if string.find(message, key) then
                        skillCounters:NewTimer(value[1], value[2])
                    end
                end
            end
        end
    end
 end

 function GetName(message)
    local sender = nil
    local x = message:sub(1, message:find("%s"))
    for word in string.gmatch(x:sub(8), "%a+") do
        --ChatOutput(word)
        if(word == "Select") then
            break
        end  
        --ChatOutput(sender)
        sender = word
    end
    return(sender)
 end

 function GetNameDemo(message)
    local sender = nil
    for word in string.gmatch(message, "%a+") do
        --ChatOutput(word)
        if(word == "Select") then
            break
        end  
        --ChatOutput(sender)
        sender = word
    end
    return(sender)
 end

 function GetName2(message)
    local sender = nil
    local breakBool = false
    for word in string.gmatch(message, "%a+") do
        if(word == "Select")then
            if not(breakBool) then
                breakBool = true
            else
                break
            end
        end  
        sender = word
    end
    return(sender)
 end

 function GetChestName(message, raid)
    local sender = ""
    for key, value in pairs(SpecialChestNames) do
        if (string.find( message,key)) then
            return(value)
        end
    end
    for word in string.gmatch(message, "%S+") do
        if(word == "Mithril") then
            --ChatOutput(word)
            break
        end  
        sender = sender..word
    end
    if sender == "" then
        for key, value in pairs(SpecialChestNames) do
            if (string.find( message,key)) then
                return(value)
            end
        end
    end
    --return(sender)
 end

function GetRaidChestName(message)
    local sender = ""
    for key, value in pairs(SpecialRaidChestNames) do
        if (string.find( message,key)) then
            return(value)
        end
    end
    --[[
    for word in string.gmatch(message, "%S+") do
        if(word == "-") then
            --ChatOutput(word)
            break
        end  
        sender = sender..word
    end
    return(sender)]]
end

function HandleNewLock(message)
    -- Check if we have a T1 raid opening
    if string.find(message, "Tier 1") then

        HandleNullLootTable()
        local chestname = GetRaidChestName(message)
        if chestname == nil then
            return nil
        end
        chestname = "T1 " .. chestname
        if LootLocks.T1RaidLocks == nil then
            LootLocks.T1RaidLocks = {}
        end
        if LootLocks.T1RaidLocks[chestname] == nil then
            --ChatOutput("Boss added")
            LootLocks.T1RaidLocks[chestname] = {}
        end
        if LootLocks.T1RaidLocks[chestname][Player:GetName()] == nil then
            LootLocks.T1RaidLocks[chestname][Player:GetName()] = 0
        end
        if lootWindow ~= nil then
            lootWindow = LootWindow()
        end
    -- Check if we have a T2/T3 raid opening
    elseif string.find(message, "Tier 2") or string.find(message, "Tier 3") then

        HandleNullLootTable()
        local chestname = GetRaidChestName(message)
        if chestname == nil then
            local chestName2 = GetChestName(message)
            if chestName2 ~= nil and  string.find(message, "Tier 3") then
                NormaleChest(message)
                return(nil)
            else
                return(nil)
            end
        end
        if string.find(message, "Tier 2") then
            chestname = "T2 " .. chestname
        elseif string.find(message, "Tier 3") then
            chestname = "T3 ".. chestname
        end
        if LootLocks.RaidLocks == nil then
            LootLocks.RaidLocks = {}
        end
        if LootLocks.RaidLocks[chestname] == nil then
            LootLocks.RaidLocks[chestname] = {}
        end
        if LootLocks.RaidLocks[chestname][Player:GetName()] == nil then
            LootLocks.RaidLocks[chestname][Player:GetName()] = 0
        end
        
        if lootWindow ~= nil then
            lootWindow = LootWindow()
        end
    -- check if we have a favoured T3 opening
    elseif string.find(message, "Mithril Chest") or string.find(message, "Mithril Reward") then
        NormaleChest(message)
    end 
end

function NormaleChest(message)
    -- Check if we already have this char in the loot table
    HandleNullLootTable()
    local chestName = GetChestName(message)
    if chestName == nil then
        return(nil)
    end
    --ChatOutput(message)
    --ChatOutput(chestName)
    if LootLocks.Locks == nil then
        LootLocks.Locks = {}
    end
    if LootLocks.Locks[chestName] == nil then
        --ChatOutput("Boss added")
        LootLocks.Locks[chestName] = {}
    end
    if LootLocks.Locks[chestName][Player:GetName()] == nil then
        LootLocks.Locks[chestName][Player:GetName()] = 1
    else
        LootLocks.Locks[chestName][Player:GetName()] = 0
    end

    if lootWindow ~= nil then
        lootWindow = LootWindow()
    end
end

function HandleNullLootTable()
        
    if LootLocks.Characters == nil then
        LootLocks.Characters = {}
    end

    if LootLocks.Characters[Player:GetName()] == nil then
        LootLocks.Characters[Player:GetName()] = true
    end
end