DNFTracker = class(Turbine.UI.Control)

function DNFTracker:Constructor()
    Turbine.UI.Control.Constructor(self);
    local DNFS = {}

    if ReloadStateData ~= nil and ReloadStateData.DNFS ~= nil then
        DNFS = ReloadStateData.DNFS
    end
    local EarliestReset = nil
    
    self.DNFApplied = function (x, name, time)
        DNFS[name] = time
    end

    self.Death = function(sender,  name )
        if DNFS[name] ~=  nil then
            if DNFS[name] > Turbine.Engine.GetGameTime() then 
                DNFS[name] = nil
                messageWindow:Message(8, "DNF on: <rgb=#009900>" .. name .. "</rgb>", DNFSmall, false)
            end
        end
    end

    self.GetDNFS = function()
        return(DNFS)
    end
end