
function SetTriggers()
  Player:GetEffects().EffectAdded = function(sender, args)
    local effect = Player:GetEffects():Get(args.Index)
    if SelfEffectsLUT[effect:GetName()] then 

      --ChatOutput(effect:GetName() .. " " .. effect:GetIcon())
      --ChatOutput(effect:GetID().." "..effect:GetName())

      
      -- Ready check
      if ReadyCheck:ReadyCheckActive() then
        --ChatOutput(effect:GetName())
        ReadyCheck:UpdateBuffWindow(Player:GetName(), effect:GetName())
      end

      if Settings.LEnabled then logWindow:Message(effect:GetName(), effect:IsDebuff()) end

      -- Effect alerts
      if Settings.AEnabled then
        local AlertTemp = E.AllEffectsAdded[effect:GetName()]
        if AlertTemp ~= nil then
          
          if AlertTemp[3] == true then AlertTemp[3] = effect:GetIcon() end
          messageWindow:Message(AlertTemp[1], AlertTemp[2] .. "<rgb=#FF0000>" .. Player:GetName() .. "</rgb>" , AlertTemp[3], AlertTemp[4])
          if AlertTemp[5] ~= nil then Sounds:PlaySoundEffect(AlertTemp[5]) end
        end
      end

      -- Add alert
      if Settings.EEnabled then
        testing = E.EffectsAdded[effect:GetName()]
        if testing ~= nil then
        --icon = nil
        --if testing[3] == nil then icon = effect:GetIcon() else icon = testing[3] end

          effectsWindow:Message(testing[1], testing[2], testing[3], testing[4], effect:GetName())
          if testing[5] ~= nil then Sounds:PlaySoundEffect(testing[5]) end
        end
      end

        -- Add timer
      if Settings.SEnabled then
        local testing1 = TEffects[effect:GetName()]
        --ChatOutput(effect:GetName())
        if testing1 ~= nil then
          --ChatOutput("YY")
          skillCounters:NewTimer(testing1[1], testing1[2])
        end
      end

      -- Skill Counters
      if Settings.SPEnabled then
        local allTemp2 = E.AllPlayerEffects[effect:GetName()]
        if allTemp2 ~= nil then
          local activityTimer1 = allTemp2[4]
          if effect:GetDuration() ~= nil  and activityTimer1 ~= nil and effect:GetDuration() < 999 then
            activityTimer1 = effect:GetDuration()
          elseif activityTimer1 == nil then
            activityTimer1 = 1
          end
          if activityTimer1 ~= nil then
            activeTimers:NewTimer(allTemp2[1], effect:GetName(), allTemp2[2], allTemp2[3], activityTimer1, allTemp2[5], effect:GetIcon(), Player:GetName())
          end
          skillTimers:NewTimer(allTemp2[1], effect:GetName(), allTemp2[2], allTemp2[3], activityTimer1, allTemp2[5], effect:GetIcon(), Player:GetName())
        end

        local temp3 = E.PlayerEffects[Player:GetClass()]
        if temp3 ~= nil then
          local temp4 = temp3[effect:GetName()]
          if temp4 ~= nil then
            local activityTimer = temp4[4]
            if effect:GetDuration() ~= nil  and activityTimer ~= nil and effect:GetDuration() < 999 then
              activityTimer = effect:GetDuration()
            elseif activityTimer == nil then
              activityTimer = 1
            end
            if activityTimer ~= nil then
              activeTimers:NewTimer(temp4[1], effect:GetName(), temp4[2], temp4[3], activityTimer, temp4[5], effect:GetIcon(), Player:GetName())
            end
            skillTimers:NewTimer(temp4[1], effect:GetName(), temp4[2], temp4[3], activityTimer, temp4[5], effect:GetIcon(), Player:GetName())
          end
        end

        local SelfEffect = E.SelfOnlyEffects[effect:GetName()]
        if SelfEffect ~= nil then
          local activityTimer1 = SelfEffect[4]
          if effect:GetDuration() ~= nil  and activityTimer1 ~= nil and effect:GetDuration() < 999 then
            activityTimer1 = effect:GetDuration()
          elseif activityTimer1 == nil then
            activityTimer1 = 1
          end
          if activityTimer1 ~= nil then
            activeTimers:NewTimer(SelfEffect[1], effect:GetName(), SelfEffect[2], SelfEffect[3], activityTimer1, SelfEffect[5], effect:GetIcon(), Player:GetName())
          end
          skillTimers:NewTimer(SelfEffect[1], effect:GetName(), SelfEffect[2], SelfEffect[3], activityTimer1, SelfEffect[5], effect:GetIcon(), Player:GetName())
        end
      end
    end
    effect = nil
  end

  if Party ~= nil then
    for i = 1, Party:GetMemberCount(), 1 do
      if Group[i].player:GetName() ~= Player:GetName() then
        Group[i].effects.EffectAdded = function(sender, args)
          local effect = Group[i].player:GetEffects():Get(args.Index)
          if not(Group[i].currentEffects[effect:GetID()]) then
            Group[i].currentEffects[effect:GetID()] = true
            if GroupEffectsLUT[effect:GetName()] then 
              --ChatOutput(effect:GetName())

              -- Ready check
              if ReadyCheck:ReadyCheckActive() then
                --ChatOutput(effect:GetName())
                ReadyCheck:UpdateBuffWindow(Group[i].player:GetName(), effect:GetName())
              end

              -- DNF tracker
              if Settings.AEnabled then
                if effect:GetName() == DNFstring then
                  rezTracker:DNFApplied(Group[i].player:GetName(), effect:GetStartTime() + effect:GetDuration())
                end
              end

              -- Effect alerts
              if Settings.AEnabled then
                local AlertTemp = E.AllEffectsAdded[effect:GetName()]
                if AlertTemp ~= nil then
                  if AlertTemp[3] == true then AlertTemp[3] = effect:GetIcon() end
                  messageWindow:Message(AlertTemp[1], AlertTemp[2] .. "<rgb=#FF0000>" .. Group[i].player:GetName() .. "</rgb>", AlertTemp[3], AlertTemp[4])
                  if AlertTemp[5] ~= nil then Sounds:PlaySoundEffect(AlertTemp[5]) end
                end
              end

              -- Skill Timers
              if Settings.SPEnabled then
                local allTemp = E.AllPlayerEffects[effect:GetName()]
                if allTemp ~= nil then
                  local activityTimer = allTemp[4]
                  if effect:GetDuration() ~= nil  and activityTimer ~= nil and effect:GetDuration() < 999 then
                    activityTimer = effect:GetDuration()
                  elseif activityTimer == nil then
                    activityTimer = 1
                  end

                  if activityTimer ~= nil then
                    activeTimers:NewTimer(allTemp[1], effect:GetName(), allTemp[2], allTemp[3], activityTimer, allTemp[5], effect:GetIcon(), Group[i].player:GetName())
                  end
                  skillTimers:NewTimer(allTemp[1], effect:GetName(), allTemp[2], allTemp[3], activityTimer, allTemp[5], effect:GetIcon(), Group[i].player:GetName())
                end

                local temp = E.PlayerEffects[Group[i].player:GetClass()]
                if temp ~= nil then
                  local temp2 = temp[effect:GetName()]
                  if temp2 ~= nil then
                    local activityTimer = temp2[4]
                    if effect:GetDuration() ~= nil  and activityTimer ~= nil and effect:GetDuration() < 999 then
                      activityTimer = effect:GetDuration()
                    elseif activityTimer == nil then
                      activityTimer = 1
                    end
                    if activityTimer ~= nil then
                      activeTimers:NewTimer(temp2[1], effect:GetName(), temp2[2], temp2[3], activityTimer, temp2[5], effect:GetIcon(), Group[i].player:GetName())
                    end
                    skillTimers:NewTimer(temp2[1], effect:GetName(), temp2[2], temp2[3], activityTimer, temp2[5], effect:GetIcon(), Group[i].player:GetName())
                  end
                end
              end

              -- Add timer
              if Settings.SEnabled then
                local testing1 = TAllEffects[effect:GetName()]
                if testing1 ~= nil then
                  skillCounters:NewTimer(testing1[1], testing1[2])
                end
              end
            end
          end
          effect = nil
        end
      end
    end
  end
end

function GroupReloads()
  Player.PartyChanged = function()
    ReloadPlugin()
    --ChatOutput("Party changed")
    --if ratTracker ~=  nil then ratTracker:UpdateText() end
  end
  Player.RaidChanged = function()
    ReloadPlugin()
    --ChatOutput("Raid changed")
    --if ratTracker ~=  nil then ratTracker:UpdateText() end
  end
  if Party ~= nil then
    Party.MemberAdded = function()
      ReloadPlugin()
      --ChatOutput("Member added")
      --if ratTracker ~=  nil then ratTracker:UpdateText() end
    end
    Party.MemberRemoved = function()
      ReloadPlugin()
      --ChatOutput("Member removed")
      --if ratTracker ~=  nil then ratTracker:UpdateText() end
    end
    Party.LeaderChanged = function()
      ReloadPlugin()
      --if ratTracker ~=  nil then ratTracker:UpdateText() end
    end

    for i = 1, Party:GetMemberCount(), 1 do
      Party:GetMember(i).IsLinkDeadChanged = function()
        ReloadPlugin()
        --ChatOutput("Link dead changed")
      end
    end
  end
end

function ResetGroupInfo()
  --Player = nil
  --Player = Turbine.Gameplay.LocalPlayer.GetInstance();
  --Name = Player:GetName();
  Party = nil
  Party = Player:GetParty();
  --ChatOutput("Before Group: " .. collectgarbage("count")*1024)
  Group = nil
  collectgarbage()
  if Party ~= nil then
    GroupSize = Party:GetMemberCount()
    Group = {}
    --ChatOutput("After Group: " .. collectgarbage("count")*1024)
    for i = 1, Party:GetMemberCount(), 1 do
        Group[i] = {};
        Group[i].player = Party:GetMember(i);
        Group[i].effects = Group[i].player:GetEffects()
        Group[i].currentEffects = {}
        GroupIDToName[Group[i].player:GetName()] = i
    end
  else
    Group = {}
    Group[1] = {};
    Group[1].player = Player;
    Group[1].effects = Group[1].player:GetEffects()
    Group[1].currentEffects = {}
    GroupIDToName[Player:GetName()] = 1
  end
  SetTriggers()
  GroupReloads()
end

function RefreshGroupData()
  if Party ~= nil then
    for i = 1, Party:GetMemberCount(), 1 do
      Group[i].effects = nil
      Group[i].currentEffects = nil
    end
    collectgarbage()
    for i = 1, Party:GetMemberCount(), 1 do
      Group[i].effects = {}
      Group[i].currentEffects = Group[i].player:GetEffects()
    end
  end
end

function SetGroup()
  Group = {};
  if Party ~= nil then
    GroupSize = Party:GetMemberCount()
    for i = 1, GroupSize, 1 do
      Group[i] = {};
      Group[i].player = Party:GetMember(i);
      Group[i].effects = Group[i].player:GetEffects()
      Group[i].currentEffects = {}
    end
  else
    Group[1] = {};
    Group[1].player = Player;
    Group[1].effects = Group[1].player:GetEffects()
    Group[1].currentEffects = {}
  end
  SetTriggers()
  GroupReloads()
end

--[[
    Player.PartyChanged = function()
    ResetGroupInfo()
    --ChatOutput("Party changed")
    --if ratTracker ~=  nil then ratTracker:UpdateText() end
  end
  Player.RaidChanged = function()
    ResetGroupInfo()
    --ChatOutput("Raid changed")
    --if ratTracker ~=  nil then ratTracker:UpdateText() end
  end
  if Party ~= nil then
    Party.MemberAdded = function()
      ResetGroupInfo()
      --ChatOutput("Member added")
      --if ratTracker ~=  nil then ratTracker:UpdateText() end
    end
    Party.MemberRemoved = function()
      ResetGroupInfo()
      --ChatOutput("Member removed")
      --if ratTracker ~=  nil then ratTracker:UpdateText() end
    end
    Party.LeaderChanged = function()
      ResetGroupInfo()
      --if ratTracker ~=  nil then ratTracker:UpdateText() end
    end

    for i = 1, Party:GetMemberCount(), 1 do
      Party:GetMember(i).IsLinkDeadChanged = function()
        ResetGroupInfo()
        --ChatOutput("Link dead changed")
      end
  end
--]]

--[[
  function ResetGroupInfo()
  --Player = nil
  --Player = Turbine.Gameplay.LocalPlayer.GetInstance();
  --Name = Player:GetName();
  Group = {};
  Party = nil
  Party = Player:GetParty();
  if Party ~= nil then
      for i = 1, Party:GetMemberCount(), 1 do
        --Group[i] = {};
        local playerName = Party:GetMember(i):GetName() 
        Group[playerName].player = Party:GetMember(i);
        Group[playerName].effects = Group[playerName].player:GetEffects()
        Group[playerName].currentEffects = {}
      end
  else
    Group[Player:GetName()] = {};
    Group[Player:GetName()].player = Player;
    Group[Player:GetName()].effects = Group[Player:GetName()].player:GetEffects()
    Group[Player:GetName()].currentEffects = {}
  end
  SetTriggers()
end

function SetGroup()
  Group = {};
  if Party ~= nil then
    GroupSize = Party:GetMemberCount()
    for i = 1, GroupSize, 1 do
      --Group[i] = {};
      local playerName = Party:GetMember(i):GetName() 
      Group[playerName].player = Party:GetMember(i);
      Group[playerName].effects = Group[i].player:GetEffects()
      Group[playerName].currentEffects = {}
    end
  else
    Group[Player:GetName()] = {};
    Group[Player:GetName()].player = Player;
    Group[Player:GetName()].effects = Group[Player:GetName()].player:GetEffects()
    Group[Player:GetName()].currentEffects = {}
  end
  SetTriggers()
end
]]